# Nacitanie dat
load("ER_vysledky.rdata")
load("GSE20194_MDACC_Expression.rdata")
clinical<-read.csv("GSE20194_MDACC_Sample_Info.csv", header=T)

# kontrola
head(ER_vysledky)
head(X)
head(clinical)

str(ER_vysledky)
str(X)
str(clinical)

# drahy
library(ToPASeq)
kegg<-pathways("hsapiens", "kegg")
head(kegg)
kegg[[1]]
nodes(kegg[[1]])
kegg<-convertIdentifiers(kegg, "symbol")
nodes(kegg[[1]])

keggSet<-lapply(kegg, nodes)
keggSetAll<-unique(unlist(keggSet))

keggSetFilter<-lapply(keggSet, function(x) 
  intersect(x, colnames(X)))
keggSetFilterAll<-unique(unlist(keggSetFilter))

# hypergeometricky test
library(Category)


degenes<-ER_vysledky$Gen[ER_vysledky$adjpval<0.05]

siggenes<-replicate(length(keggSet), degenes, simplify = F)
siggenes<-Map(function(x, y) x[x %in% y], keggSetFilter,siggenes )

hyperg_vysledky<-hyperg(keggSetFilter, siggenes, colnames(X), "over")
hyperg_vysledky$padj<-p.adjust(hyperg_vysledky$p, "BH")
head(hyperg_vysledky)


hyperg_vysledky2<-hyperg(keggSetFilter, siggenes, keggSetFilterAll, "over")
hyperg_vysledky2$padj<-p.adjust(hyperg_vysledky2$p, "BH")
head(hyperg_vysledky2)

# GSA
GSA_vysledky<-GSA::GSA(t(X),as.numeric(clinical$ER_status), keggSet, colnames(X),
    method="mean", resp.type="Two class unpaired")

GSA_vysledky$fdr.hi
GSA_vysledky$fdr.lo

GSA_vysledky$pvalues.hi
GSA_vysledky$pvalues.lo

GSA::GSA.plot(GSA_vysledky)

GSA::GSA.listsets(GSA_vysledky, geneset.names=names(keggSet),FDRcut=1)

GSA_vysledky2<-GSA::GSA(t(X),as.numeric(clinical$ER_status), keggSetFilter, colnames(X),
                       method="maxmean", resp.type="Two class unpaired")
GSA::GSA.plot(GSA_vysledky2)
# S topologiou
spia_vysledky<-SPIA(t(X), clinical$ER_status, kegg, type="MA", logFC.th = -1)
head(spia_vysledky[[1]][[1]])